#include "uart.h"
#define UART_RX_BUF 10


static uint8_t rxbuffer[UART_RX_BUF];
static uint8_t rxIn;
static uint8_t rxOut;
static uint8_t txIn;
static uint8_t txOut;


ISR(USART0_RX_vect)
{
	rxbuffer[rxIn] = UDR0;
	rxIn++;
	if (rxIn >= UART_RX_BUF)
		rxIn = 0;
}


ISR(USART0_TX_vect)
{

}


void init_uart()
{
	/*UART initialisieren*/
	UBRR0H = UBR_VAL >> 8;
	UBRR0L = UBR_VAL & 0xFF;
	UCSR0B |= (1 << TXEN0);
	UCSR0C =  (1<<UCSZ01) | (1<<UCSZ00);  						// TODO: RICHTIG?
	//UCSRC = (1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0);  			// --> fr ATmega16

	rxIn = rxOut = 0;
	txIn = txOut = 0;
}


int uart_putc(unsigned char c)
{
    while (!(UCSR0A & (1 << UDRE0)))
    {
    }

    UDR0 = c;
    return 0;
}


void uart_puts (char *s)
{
    while (*s)
    {
    	uart_putc(*s);
        s++;
    }
}
